package com.casic.dcms.mvp.model;

import com.casic.dcms.bean.PhoneBookBean;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

/**
 * @author : Pengxh
 * @time : 2021/4/15 11:21
 * @email : 290677893@qq.com
 **/
public class PhoneBookModelImpl implements IPhoneBookModel {

    private OnGetPhoneBookListener listener;

    public PhoneBookModelImpl(OnGetPhoneBookListener bookListener) {
        this.listener = bookListener;
    }

    /**
     * 数据回调接口
     */
    public interface OnGetPhoneBookListener {
        void onSuccess(PhoneBookBean resultBean);

        void onFailure(Throwable throwable);
    }

    @Override
    public Subscription sendRetrofitRequest(String deptid) {
        Observable<PhoneBookBean> observable = RetrofitServiceManager.getPhoneBookResult(deptid);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<PhoneBookBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    listener.onFailure(e);
                }
            }

            @Override
            public void onNext(PhoneBookBean resultBean) {
                if (resultBean != null) {
                    listener.onSuccess(resultBean);
                }
            }
        });
    }
}
